Program Tree1;
Const MaxN = 1000000;
Type DataArr = Array [1..MaxN] of LongInt;

Procedure Print(var f:Text; v: DataArr; n: LongInt);
Var i: LongInt;
Begin
  Write(f, v[1]);
  For i:= 2 To n Do Begin
    Write(f, ' ',v[i]);
  End;
  Writeln(f);
End;

Procedure NextLCode(var f:Text; v: DataArr; n: LongInt);
Var m: LongInt;
Begin
  m:= n;
  While v[m-1]=v[m]-1 Do Begin
    v[m]:= 1;
    Dec(m);
  End;
  // v[m] - ᠬ ࠢ 設,   (⮬  ।);
  // ᪠    ஢,    ⮬ (, 㪨  ..)
  // ⠭ 쬨  ॢ
  Inc(v[m]);
  Print(f, v, n);
End;

Procedure NextNCode(var f: Text; v: DataArr; n: LongInt);
Var m, k1, k2, kmax, vm: LongInt;
Begin
  kmax:= 1;
  For m:= 1 To n-2 Do Begin
    If v[m]>v[m+1]+1 Then Begin
      k2:= m+1;
      vm:= v[m]-1;
      Repeat
        k1:= k2;
        Dec(vm, v[k1]);
        k2:= k1+v[k1];
      Until v[k2]=vm;
      If k1>kmax Then kmax:= k1;
    End;
  End;
  //v[kmax] - ᠬ ࠢ  N- 設,  ⠪ ᢮⢮:
  // 1.  த⥫    ⮬,  
  // 2. ࠢ   N- 室 ஢    (⮬  ।)
  Inc(v[kmax]);
  For k1:= kmax+1 To n Do Begin
      v[k1]:= 1;
  End;
  Print(f, v, n);
End;

Procedure L2N(var f: Text; v: DataArr; n: LongInt);
Var RightestPath: Array [0..MaxN-1] of LongInt;
    RightestPathLength, i, j: LongInt;
Begin
  RightestPath[0]:= 1;
  RightestPathLength:= 0;
  For i:= 2 To n Do Begin
    If v[i] <= RightestPathLength Then Begin
      For j:= v[i] To RightestPathLength Do Begin
        v[RightestPath[j]]:= i-RightestPath[j];
      End;
    End;
    RightestPathLength:= v[i];
    RightestPath[RightestPathLength]:= i;
  End;
  For j:= 0 To RightestPathLength Do Begin
    v[RightestPath[j]]:= n+1-RightestPath[j];
  End;
  Print(f, v, n);
End;

Procedure N2L(var f: Text; v: DataArr; n: LongInt);
Var stack: Array [0..MaxN-1] of LongInt;
    top, i: LongInt;
Begin
  top:= 0;
  stack[0]:= v[1]-1+1;
  v[1]:= 0;
  For i:= 2 To n Do Begin
    Dec(stack[top], v[i]);
    Inc(top);
    stack[top]:= v[i]-1;
    v[i]:= top;
    While stack[top]=0 Do Begin
      Dec(top);
    End;
  End;
  Print(f, v, n);
End;

Var fin, fout: Text;
    tree: DataArr;
    n: LongInt;
Begin
  Assign(fin, 'treecode.in'); Reset(fin);
  Assign(fout, 'treecode.out'); Rewrite(fout);
  n:= 0;
  While not SeekEoLn(fin) Do Begin
    Inc(n);
    Read(fin, tree[n]);
  End;
  Readln(fin);
  NextNCode(fout, tree, n);
  N2L(fout, tree, n);
  n:= 0;
  While not SeekEoF(fin) Do Begin
    Inc(n);
    Read(fin, tree[n]);
  End;
  Close(fin);
  NextLCode(fout, tree, n);
  L2N(fout, tree, n);
  Close(fout);
End.
